<?php
namespace Pinpoint\Feefo\Controller\Adminhtml\Order;

use Magento\Backend\App\Action;
use Magento\Backend\App\Action\Context;
use Magento\Framework\View\Result\PageFactory;

class SendToFeefo extends Action
{
    /**
     * @var PageFactory
     */
    protected $resultPageFactory;

    /**
     * @var \Magento\Sales\Model\OrderRepository
     */
    private $orderRepository;

    /**
     * @param Context $context
     * @param \Magento\Sales\Model\OrderRepository $orderRepository
     * @param PageFactory $resultPageFactory
     */
    public function __construct(
        Context $context,
        \Magento\Sales\Model\OrderRepository $orderRepository,
        PageFactory $resultPageFactory
    ) {
        parent::__construct($context);

        $this->resultPageFactory = $resultPageFactory;
        $this->orderRepository = $orderRepository;
    }

    /**
     * Check the permission to run it
     *
     * @return boolean
     */
    protected function _isAllowed()
    {
        return $this->_authorization->isAllowed('');
    }

    /**
     * Index action
     *
     * @return \Magento\Framework\Controller\ResultInterface
     */
    public function execute()
    {
        $sendToFeefo = $this->getRequest()->getParam('send_to_feefo');
        $orderId = $this->getRequest()->getParam('order_id');

        //if we have been passed the required details, load order and apply feefo flag
        if (!is_null($sendToFeefo) && $orderId) {
            $order = $this->orderRepository->get($orderId);
            $order->setSendToFeefo($sendToFeefo);

            $this->orderRepository->save($order);
        }

        $resultRedirect = $this->resultRedirectFactory->create();

        $resultRedirect->setUrl($this->_redirect->getRefererUrl());
        return $resultRedirect;
    }
}
